"use strict";

{
	C3.Behaviors.CV_BoundedDragnDrop.Instance = class BoundedDragnDropInstance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties)
		{
			super(behInst);

			const WI = this._inst.GetWorldInfo();

			 if (properties) 
			 {
				this.axes = properties[0];
				this.enabled = properties[1];

				this.dragging = false;
				this.dx = 0;
				this.dy = 0;
				this.dragsource = "<none>";
				
				// 0 = both, 1 = horizontal, 2 = vertical
				this.axes = properties[0];
				this.enabled = (properties[1] !== 0);
		
				//Chadori_RebornXD start
					//user-defined
				this.boundTo = properties[2];
				this.boundBy = properties[3];
				this.boundMethod = properties[4];
				this.boundXRadius = properties[5];
				this.boundYRadius = properties[6];
				this.boundMinX = properties[7];
				this.boundMaxX = properties[8];
				this.boundMinY = properties[9];
				this.boundMaxY = properties[10];
					//background
				this.boundEnabled = false;
				this.radiusBound = false;
				this.posBound = false;
				this.posX = WI.GetX();
				this.posY = WI.GetY();
					//dedicated for expressions
				this.radiusExceeded = false;
				this.positionExceeded = false;
		
				this.getBoundValues = function ()
				{
		
					//Off
					if (this.boundTo === 0)
					{
							//All (false)
							this.boundEnabled = false;
							this.radiusBound = false;
							this.posBound = false;	
								
					}
		
					//Both
					else if (this.boundTo === 1)
					{
		
						//Enable Bound (true)
						this.boundEnabled = true;
		
						//Radius (true)
						if (this.boundXRadius !== 0 || this.boundYRadius !== 0)	
						{
							this.radiusBound = true;
		
							//XAxis Adjust
							if(this.boundXRadius === 0)
							{
								if (this.axes === 0 || this.axes === 1)
								{
									this.axes = 2;
								}
							}
							//YAxis Adjust
							if(this.boundYRadius === 0)
							{
								if (this.axes === 0 || this.axes === 2)
								{
									this.axes = 1;
								}
							}
		
		
						}
		
						else 
						{
							this.radiusBound = false;
						}
		

						//Position (true)
							this.posBound = true;
		
					}
		
		
		
					else if (this.boundTo === 2)
					{
		
						if (this.boundXRadius !== 0 || this.boundYRadius !== 0)
						
						{
							//Enable Bound (true)
							this.boundEnabled = true;
		
							//Radius (true)
							if (this.boundXRadius !== 0 || this.boundYRadius !== 0)	
							{
		
								this.radiusBound = true;
		
		
								//XAxis Adjust
								if(this.boundXRadius === 0)
								{
									if (this.axes === 0 || this.axes === 1)
									{
										this.axes = 2;
									}
								}
								//YAxis Adjust
								if(this.boundYRadius === 0)
								{
									if (this.axes === 0 || this.axes === 2)
									{
										this.axes = 1;
									}
								}
		
		
							}
		
							else 
							{
								this.radiusBound = false;
							}
		
		
		
							//Position (false)
							this.posBound = false;
		
						}		
					}
		
					else // (this.boundTo === 3)
					{
							//Enable Bound (true)
							this.boundEnabled = true;
		
							//radius (false)
							this.radiusBound = false;
		
							//position (true)
							this.posBound = true;
					}
		
		
				}
		
				this.getBoundValues();

			 }

			 this.inst = {

				 get : {
				 	x : WI.GetX(),
					y : WI.GetY()
				 },

				 set : {
					x : function (a) { return WI.SetX(a) },
					y : function (b) { return WI.SetY(b) }
				 },

				 set_bbox_changed : function() 
				 {
					WI.SetBboxChanged();
				 },

				 hotspotX : WI.GetOriginX(),

				 hotspotY : WI.GetOriginY(),

				 width : WI.GetWidth(),

				 height : WI.GetHeight()

			 }
		}

		Release()
		{
			super.Release();
		}
		
		SaveToJson()
		{
			return {
                "a" : this.axes,
                "e" : this.enabled
			};
		}

		LoadFromJson(o)
		{
			this.axes 	  = o["a"]; 
			this.enabled  = o["e"]; 
			this.dragging = false;
		}
		
		// -- Construct 3 Runtime -> Instancse Class Functions :: Start

		IsEnabled() 
		{
            return this.enabled;
		}
		
		IsDragging() 
		{
            return this.dragging;
		}
		
		GetDragSource() 
		{
            return this.dragsource;
		}
		
		// "_ClassFunction"s are Construct 3 Runtime  Custom Class Functions.

		_OnDown(a, b, c) 
		{
            const d = this.GetWorldInfo();
			this.dx = b - d.GetX(); 
			this.dy = c - d.GetY(); 
			this.dragging = true;
			this.dragsource = a; 
			this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnDragStart);
		}
		
		_OnMove(x, y) 
		{
			var newx = x - this.dx;
			var newy = y - this.dy;

				 if (this.axes === 0)	// both
			{

				//If one or more Bound values aren't 0.
				if (this.boundEnabled)	
				{
					//origin
					if (this.boundBy === 0)
					{
						//Radius
						this.limitLowX = this.posX - this.boundXRadius;
						this.limitHighX = this.posX + this.boundXRadius;
						this.limitLowY = this.posY - this.boundYRadius;
						this.limitHighY = this.posY + this.boundYRadius;
						//Position
						this.limitLowPosX = this.boundMinX;
						this.limitHighPosX = this.boundMaxX;
						this.limitLowPosY = this.boundMinY;
						this.limitHighPosY = this.boundMaxY;
						//Boolean
						var radiusClear = false;
						var posClear = false;

						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newx < this.limitLowX || newx > this.limitHighX || newy < this.limitLowY || newy > this.limitHighY)
							{
								radiusClear = false; //not necessary (redundant)
								
								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);
								
							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;
							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newx < this.limitLowPosX || newx > this.limitHighPosX || newy < this.limitLowPosY || newy > this.limitHighPosY)
							{
								posClear = false; //not necessary (redundant)

								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);

							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;
							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.x !== newx || this.inst.get.y !== newy)	
								{					
									this.inst.set.x(newx);
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.x !== newx || this.inst.get.y !== newy)	
								{					
									this.inst.set.x(newx);
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}

						}
					}

					//edge
					else 

					{
						//Hotspot
						var hotspotX = this.inst.hotspotX;
						var hotspotY = this.inst.hotspotY;

						var hotspotWidthLeft = (hotspotX * this.inst.width);
						var hotspotWidthRight = ((1 - hotspotX) * this.inst.width);

						var hotspotHeightTop = (hotspotY * this.inst.height);
						var hotspotHeightBottom = ((1 - hotspotY) * this.inst.height);

						//Radius
						this.limitLowX = (this.posX + hotspotWidthLeft) - this.boundXRadius;
						this.limitHighX = (this.posX - hotspotWidthRight) + this.boundXRadius;
						this.limitLowY = (this.posY + hotspotHeightTop) - this.boundYRadius;
						this.limitHighY = (this.posY - hotspotHeightBottom) + this.boundYRadius;
						//Position
						this.limitLowPosX = this.boundMinX + hotspotWidthLeft;
						this.limitHighPosX = this.boundMaxX - hotspotWidthRight;
						this.limitLowPosY = this.boundMinY + hotspotHeightTop;
						this.limitHighPosY = this.boundMaxY - hotspotHeightBottom;
						//Boolean
						var radiusClear = false;
						var posClear = false;
						

						//Set New Position

						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newx < this.limitLowX || newx > this.limitHighX || newy < this.limitLowY || newy > this.limitHighY)
							{
								radiusClear = false; //not necessary (redundant)

								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);

							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;

							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newx < this.limitLowPosX || newx > this.limitHighPosX || newy < this.limitLowPosY || newy > this.limitHighPosY)
							{
								posClear = false; //not necessary (redundant)

								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);
							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;

							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.x !== newx || this.inst.get.y !== newy)	
								{					
									this.inst.set.x(newx);
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.x !== newx || this.inst.get.y !== newy)	
								{					
									this.inst.set.x(newx);
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}

						}


					}
					
				}
				//If all Bound values are 0.
				else
				{


					if (this.inst.get.x !== newx || this.inst.get.y !== newy)	
					{					
						this.inst.set.x(newx);
						this.inst.set.y(newy);
						this.inst.set_bbox_changed();
					}

				}
				
			}
		
			else if (this.axes === 1)	// horizontal
			{				
				//If one or more Bound values aren't 0.
				if (this.boundEnabled)	
				{
					//origin
					if (this.boundBy === 0)
					{
						//Radius
						this.limitLowX = this.posX - this.boundXRadius;
						this.limitHighX = this.posX + this.boundXRadius;
						//Position
						this.limitLowPosX = this.boundMinX;
						this.limitHighPosX = this.boundMaxX;
						//Boolean
						var radiusClear = false;
						var posClear = false;

						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newx < this.limitLowX || newx > this.limitHighX)
							{
								radiusClear = false; //not necessary (redundant)

								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);


							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;

							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newx < this.limitLowPosX || newx > this.limitHighPosX)
							{
								posClear = false; //not necessary (redundant)

								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);

							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;

							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.x !== newx)	
								{					
									this.inst.set.x(newx);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.x !== newx)	
								{					
									this.inst.set.x(newx);
									this.inst.set_bbox_changed();
					
								}

						}

					}

					//edge
					else 

					{

						//Hotspot
						var hotspotX = this.inst.hotspotX;

						var hotspotWidthLeft = (hotspotX * this.inst.width);
						var hotspotWidthRight = ((1 - hotspotX) * this.inst.width);

						//Radius
						this.limitLowX = (this.posX + hotspotWidthLeft) - this.boundXRadius;
						this.limitHighX = (this.posX - hotspotWidthRight) + this.boundXRadius;
						//Position
						this.limitLowPosX = this.boundMinX + hotspotWidthLeft;
						this.limitHighPosX = this.boundMaxX - hotspotWidthRight;
						//Boolean
						var radiusClear = false;
						var posClear = false;

						//Set New Position

						
						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newx < this.limitLowX || newx > this.limitHighX)
							{
								radiusClear = false; //not necessary (redundant)

								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);

							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;

							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newx < this.limitLowPosX || newx > this.limitHighPosX)
							{
								posClear = false; //not necessary (redundant)
								
								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);

							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;

							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.x !== newx)	
								{					
									this.inst.set.x(newx);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.x !== newx)	
								{					
									this.inst.set.x(newx);
									this.inst.set_bbox_changed();
					
								}

						}


					}
					
				}
				//If all Bound values are 0.
				else
				{


					if (this.inst.get.x !== newx)
					{
						this.inst.set.x(newx);
						this.inst.set_bbox_changed();
					}
		

				}
				
			}

			else if (this.axes === 2)	// vertical
			{
				//If one or more Bound values aren't 0.
				if (this.boundEnabled)	
				{
					//origin
					if (this.boundBy === 0)
					{
						//Radius
						this.limitLowY = this.posY - this.boundYRadius;
						this.limitHighY = this.posY + this.boundYRadius;
						//Position
						this.limitLowPosY = this.boundMinY;
						this.limitHighPosY = this.boundMaxY;
						//Boolean
						var radiusClear = false;
						var posClear = false;

						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newy < this.limitLowY || newy > this.limitHighY)
							{
								radiusClear = false; //not necessary (redundant)

								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);


							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;

							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newy < this.limitLowPosY || newy > this.limitHighPosY)
							{
								posClear = false; //not necessary (redundant)

								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);

							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;

							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.y !== newy)	
								{					
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.y !== newy)	
								{					
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}

						}
			

					}

					//edge
					else 

					{
						//Hotspot
						var hotspotY = this.inst.hotspotY;
										
						var hotspotHeightTop = (hotspotY * this.inst.height);
						var hotspotHeightBottom = ((1 - hotspotY) * this.inst.height);

						//Radius
						this.limitLowY = (this.posY + hotspotHeightTop) - this.boundYRadius;
						this.limitHighY = (this.posY - hotspotHeightBottom) + this.boundYRadius;
						//Position
						this.limitLowPosY = this.boundMinY + hotspotHeightTop;
						this.limitHighPosY = this.boundMaxY - hotspotHeightBottom;
						//Boolean
						var radiusClear = false;
						var posClear = false;

						//Set New Position

						
						//Set Clearance
						//radiusBound clearance
						if (this.radiusBound)
						{
							if (newy < this.limitLowY || newy > this.limitHighY)
							{
								radiusClear = false; //not necessary (redundant)

								//radius Exceeded
								this.radiusExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnRadiusExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnRadiusExceeded);

							}
							
							else 
							{

								radiusClear = true;

								//radius !Exceeded
								this.radiusExceeded = false;

							}
						
						}

						else
						{
							radiusClear = true;

							//radius !Exceeded
							this.radiusExceeded = false;

						}

						//posBound clearance
						if (this.posBound)
						{
							if (newy < this.limitLowPosY || newy > this.limitHighPosY)
							{
								posClear = false; //not necessary (redundant)

								//position Exceeded
								this.positionExceeded = true;

								//OnAnyBoundExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnAnyBoundExceeded);

								//OnPositionExceeded conditional trigger
								this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnPositionExceeded);

							}
							
							else 
							{

								posClear = true;

								//position !Exceeded
								this.positionExceeded = false;

							}
						
						}

						else
						{
							posClear = true;

							//position !Exceeded
							this.positionExceeded = false;

						}


						//Set New Position
						//BoundMethod = 'Halt'
						if (this.boundMethod === 0)
						{

							if (radiusClear && posClear)
							{
								if (this.inst.get.y !== newy)	
								{					
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}
							}

						}
						//BoundMethod = 'Clamp'
						else
						{
							//!RadiusClear
							if (!radiusClear)
							{
								//RadiusX
								if (newx < this.limitLowX)
								{

									newx = this.limitLowX;

								}
								
								if (newx > this.limitHighX)
								{

									newx = this.limitHighX;

								}
								//RadiusY
								if (newy < this.limitLowY)
								{

									newy = this.limitLowY;

								}
								
								if (newy > this.limitHighY)
								{

									newy = this.limitHighY;

								}

							}
							//!PosClear
							if (!posClear)
							{
								//PosX
								if (newx < this.limitLowPosX)
								{

									newx = this.limitLowPosX;

								}
								
								if (newx > this.limitHighPosX)
								{

									newx = this.limitHighPosX;

								}
								//PosY
								if (newy < this.limitLowPosY)
								{

									newy = this.limitLowPosY;

								}
								
								if (newy > this.limitHighPosY)
								{

									newy = this.limitHighPosY;

								}

							}

							//New Position

							if (this.inst.get.y !== newy)	
								{					
									this.inst.set.y(newy);
									this.inst.set_bbox_changed();
					
								}

						}


					}
				}
				//If all Bound values are 0.
				else
				{


					if (this.inst.get.y !== newy)	
					{					
						this.inst.set.y(newy);
						this.inst.set_bbox_changed();
					}

				}
			}

        }
        _OnUp() {
            this.dragging = !1, this.Trigger(C3.Behaviors.CV_BoundedDragnDrop.Cnds.OnDrop)
        }
        _GetPropertyValueByIndex(a) {
            return a === 0 ? this.axes : 1 === a ? this.enabled : void 0
        }
        _SetPropertyValueByIndex(a, b) {
            a === 0 ? this.axes = b : 1 === a ? this.enabled = !!b : void 0
        }

		// -- Construct 3 Runtime -> Instancse Class Functions :: End

	};
}